"""new resource fields

Revision ID: 1aa9abac2fb4
Revises: c6d6cabde673
Create Date: 2025-03-20 17:20:02.902150

"""
from alembic import op
import sqlalchemy as sa
import falcon_rest
import api_dnl
import imp,os

#alembic_helpers = imp.load_source('alembic_helpers', ( op.get_context().script.dir + '/alembic_helpers.py'))
#if not alembic_helpers.table_has_column('xxxx', 'yyyy'):

from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = '1aa9abac2fb4'
down_revision = 'c6d6cabde673'
branch_labels = None
depends_on = None


def upgrade():
    query = '''BEGIN;

    /* Support toll-free numbers in STI-AS */
    ALTER TABLE resource ADD COLUMN shaken_sign_tollfree boolean;
    COMMENT ON COLUMN resource.shaken_sign_tollfree IS 'Sign toll-free numbers';

    /* Apply STIR/SHAKEN validation rules only to US/CA numbers */
    ALTER TABLE resource ADD COLUMN shaken_vfy_us_ca_only boolean;
    COMMENT ON COLUMN resource.shaken_vfy_us_ca_only IS 'Apply STIR/SHAKEN rules only to US/CA numbers';

    /* Add media IP to cdr reports */
    ALTER TABLE cdr_report_detail ADD COLUMN origination_remote_payload_ip_address text;
    ALTER TABLE cdr_report_detail ADD COLUMN termination_remote_payload_ip_address text;
    ALTER TABLE cdr_report_daily ADD COLUMN origination_remote_payload_ip_address text;
    ALTER TABLE cdr_report_daily ADD COLUMN termination_remote_payload_ip_address text;
    
    ALTER TABLE client ADD COLUMN mask_did_start_post integer;
    ALTER TABLE client ADD COLUMN mask_did_end_post integer;

    COMMIT;
    '''
    connection = op.get_bind()
    connection.execute(query)

    up_rec('resource')
    up_rec('client')

def downgrade():
    pass


"""
ADDONS
"""
def up_rec(table):
    """
    create record table and triggers for table
    :return:
    """
    sql= """
    --{table} trigger--
drop trigger IF EXISTS class4_trig_record_{table} on {table};
drop table IF EXISTS {table}_record;
DROP FUNCTION IF EXISTS class4_trigfun_record_{table}();
DROP SEQUENCE IF EXISTS {table}_record_record_id_seq;
SELECT * INTO {table}_record FROM {table} where false;
alter table {table}_record add time numeric;
alter table {table}_record add flag character(1);
alter table {table}_record add record_id integer;
alter table {table}_record alter COLUMN record_id SET NOT NULL;
create SEQUENCE {table}_record_record_id_seq;
alter table {table}_record alter COLUMN record_id SET DEFAULT nextval('{table}_record_record_id_seq'::regclass);

create function class4_trigfun_record_{table}() returns trigger as $$
begin
        if(TG_OP='INSERT')then
                insert into {table}_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'I';
        elseif(TG_OP='DELETE')then
                insert into {table}_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'D';
        elseif(TG_OP='UPDATE')then
                insert into {table}_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'B';
                insert into {table}_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'A';
        end if;
return null;
end;
$$ language plpgsql;

create trigger class4_trig_record_{table} after update or insert or delete on {table} for each row execute procedure class4_trigfun_record_{table}();

create index c4_{table}_record_id_idx on {table}_record (record_id);
create index {table}_record_time_idx on {table}_record using btree (time);
    """
    connection = op.get_bind()
    connection.execute(sql.format_map(dict(table=table)))

